<template>
    <xn-form-container
        :title="formData.typeId ? '编辑帖子分类表' : '增加帖子分类表'"
        :width="700"
        :visible="visible"
        :destroy-on-close="true"
        @close="onClose"
    >
        <a-form ref="formRef" :model="formData" :rules="formRules" layout="vertical">
            <a-form-item label="分类名称：" name="typeName">
                <a-input v-model:value="formData.typeName" placeholder="请输入分类名称" allow-clear />
            </a-form-item>
            <a-form-item label="分类描述：" name="typeDesc">
                <a-input v-model:value="formData.typeDesc" placeholder="请输入分类描述" allow-clear />
            </a-form-item>
        </a-form>
        <template #footer>
            <a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
            <a-button type="primary" @click="onSubmit" :loading="submitLoading">保存</a-button>
        </template>
    </xn-form-container>
</template>

<script setup name="forumPostTypeForm">
    import { cloneDeep } from 'lodash-es'
    import { required } from '@/utils/formRules'
    import forumPostTypeApi from '@/api/forum/forumPostTypeApi'
    // 抽屉状态
    const visible = ref(false)
    const emit = defineEmits({ successful: null })
    const formRef = ref()
    // 表单数据
    const formData = ref({})
    const submitLoading = ref(false)

    // 打开抽屉
    const onOpen = (record) => {
        visible.value = true
        if (record) {
            let recordData = cloneDeep(record)
            formData.value = Object.assign({}, recordData)
        }
    }
    // 关闭抽屉
    const onClose = () => {
        formRef.value.resetFields()
        formData.value = {}
        visible.value = false
    }
    // 默认要校验的
    const formRules = {
    }
    // 验证并提交数据
    const onSubmit = () => {
        formRef.value.validate().then(() => {
            submitLoading.value = true
            const formDataParam = cloneDeep(formData.value)
            forumPostTypeApi
                .forumPostTypeSubmitForm(formDataParam, formDataParam.typeId)
                .then(() => {
                    onClose()
                    emit('successful')
                })
                .finally(() => {
                    submitLoading.value = false
                })
        })
    }
    // 抛出函数
    defineExpose({
        onOpen
    })
</script>
